4S-ADMIN(5J)

NAME
4store.conf - 4store configuration file

DESCRIPTION
The file /etc/4store.conf contains settings used by 4s-admin(1), 4s-boss(8), 4s-httpd, 4s-import(1) and 4s-query(1).

  File format
The config file uses GLib's key file format, which contains key-value pairs organised into groups. The syntax of the file is as follows:

Blank lines or beginning with a hash character are considered comments:
    # this is a comment

Groups are defined by enclosing a group name within square brackets:
    [first group]
    [group2]

Each key-value pair must be placed on a new line, and will belong to the group above it.

A key-value pair is specified using 'key=values', where values can be a semicolon separated list of strings:
    [group1]
    ids=1;2;3
    people=Alice;Bob
    [group2]
    disable_foo=false

  Store options
These are options which will affect the running of 4s-backend and 4s-httpd.

To set them for all stores, place them in an option group named [default].

To set them on a single store, place them in an option group with the same name as the store, e.g. [store1].

Options:

unsafe = true|false
    Enable unsafe operations (such as LOAD). Default is false.

cors = true|false
    Enables CORS. Default is false.

port = <port_number>
    Port to run HTTP SPARQL daemon (4s-httpd) on. Default is 8080.

default-graph = true|false
    Set the default graph to be a union of named graphs. Default is false.

soft-limit = <limit>
    Sets the soft limit, or set to 0 to disable. Default is 2000.

opt-level = <level>
    Set the optimisation level, from 0 to 3. Default is 3 (all optimisations enabled).

listen = <hostname>|<ip_address>
    The hostname or IP address that 4s-httpd should listen on. Default is localhost.

  4s-boss options
These options are used to configure 4s-boss(8), and set how and if it should be used for store discovery.

These options should all be in a group named [4s-boss].

Options:

port = <port_number>
    Set port to run 4s-boss daemon on. Default is 6733.

discovery = none|sole|default
    Determines how 4s-boss is used for store discovery. Default is none.

nodes = <hostname_or_ip>[:<port>];...
    List of nodes in the cluster which run 4s-boss. Default is localhost.

Set discovery to none to use Avahi/DNS-SD for discovery instead of 4s-boss. Set to sole to use 4s-boss as the only discovery mechanism. Set to default to use use 4s-boss for discovery, but fall back to Avahi/DNS-SD.

The nodes option sets the hosts and ports of storage nodes in a 4store cluster that uses 4s-boss. Hosts can be specified either as hostnames or IPv4/IPv6 addresses, optionally followed by a colon character and port number (assumes default port of 6733 if no port is specified).

To specify a port number with an IPv6 address, enclose the address in square brackets, e.g.:
    [2001:db8::1]:6733

FILES

/etc/4store.conf

EXAMPLES

    # Global settings
    [default]
        unsafe = true
        cors = true
    # Options for store 'kb1'
    [kb1]
        port = 8888
        default-graph = false
        soft-limit = 0
        opt-level = 3
    # Options for store 'store2'
    [store2]
        soft-limit = 20000
        port = 8090
    # Enable discovery using 4s-boss, and define a 4 node cluster on:
    #   HOST                PORT
    #   host.example.org    6733 (default)
    #   192.0.2.1           6734
    #   ::1                 6733 (default)
    #   2001:db8::1         6735
    [4s-boss]
        port = 6733
        discovery = sole
        nodes = host.example.org;192.0.2.1:6734;::1;[2001:db8::1]:6735

SEE ALSO
4s-admin(1), 4s-boss(8), 4s-import(1), 4s-query(1)

GLib key file description: http://developer.gnome.org/glib/2.28/glib-Key-value-file-parser.html#glib-Key-value-file-parser.description